#ifndef MISC_H
#define MISC_H
#include<limits.h>

#undef RAND_MAX
#define RAND_MAX UINT_MAX

#define CACHELINE_REAL 64

#if 1
extern inline void prefetchtest(const void *x)
{       
	__asm__ __volatile__ ("prefetchnta (%0)" : : "r"(x));
}
#else
extern inline void prefetchtest(const void *x)
{
}
#endif

#define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)

/**
 * container_of - cast a member of a structure out to the containing structure
 *
 * @ptr:        the pointer to the member.
 * @type:       the type of the container struct this is embedded in.
 * @member:     the name of the member within the struct.
 *
 */
#define container_of(ptr, type, member) ({                      \
        const typeof( ((type *)0)->member ) *__mptr = (ptr);    \
        (type *)( (char *)__mptr - offsetof(type,member) );})


typedef volatile unsigned int	spinlock_t;

#if 1
#define spin_lock_init(lock) do { *(lock) = 0; } while(0)
#define spin_lock(lock) do { if (*lock != 0) printf("lock %p already locked\n", lock); *lock = 1;} while(0)
#define spin_unlock(lock) do { if (*lock != 1) printf("lock %p already unlocked\n", lock); *lock = 0;} while (0)
#else
#define spin_lock_init(lock)
#define spin_lock(lock)
#define spin_unlock(lock)
#endif

#endif
